'use strict';
/* Box drawing symbols
* https://en.wikipedia.org/wiki/Box-drawing_character
* ─ │ ┌ ┐ └ ┘
* ├ ┤ ┬ ┴ ┼
* ╭ ╮ ╯ ╰ ╱ ╲
* ╴ ╵ ╶ ╷ ×
*/

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.drawDevices = drawDevices;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _terminal = _interopRequireDefault(require("./terminal"));

var write = function write(msg) {
  return _terminal["default"].log(null, msg);
};

function drawDevices(rows, head) {
  var sizes;
  sizes = head.map(function (_ref) {
    var name = _ref.name,
        key = _ref.key;
    return [name].concat((0, _toConsumableArray2["default"])(rows.map(function (item) {
      return item[key];
    }))).sort(function (a, b) {
      return (b || '').length - (a || '').length;
    })[0].length + 2;
  });

  _terminal["default"].success('There are your devices:');

  write("\u250C".concat(sizes.map(function (n) {
    return '─'.repeat(n);
  }).join('┬'), "\u2510"));
  write("\u2502".concat(head.map(function (v, i) {
    return " ".concat(v.name).concat(' '.repeat(sizes[i] - v.name.length - 1));
  }).join('│'), "\u2502"));
  rows.forEach(function (row) {
    write("\u251C".concat(sizes.map(function (n) {
      return '─'.repeat(n);
    }).join('┼'), "\u2524"));
    var line = '│' + head.map(function (v, i) {
      var value = row[v.key] || '';
      return " ".concat(value).concat(' '.repeat(sizes[i] - value.length - 1));
    }).join('│') + '│';
    write(line);
  });
  write("\u2514".concat(sizes.map(function (n) {
    return '─'.repeat(n);
  }).join('┴'), "\u2518"));
}